local path = (...):gsub("[^%.]*$", "")
local Inky = require("3rd.inky")
local Button = require(path .. "button")
local Checkbox = require(path .. "checkbox")
local g = require("global")
local nineBgmenu
nineBgmenu = require(path .. "nine").nineBgmenu
local scene = Inky.scene()
local pointer = Inky.pointer(scene)
local wait_for_input
local buttons = {
  start = Button.new(scene),
  options = Button.new(scene)
}
buttons.start.props.text = function()
  return TEXT(344, "Start game")
end
buttons.options.props.text = function()
  return TEXT(345, "Options")
end
buttons.start.props.callback = function()
  g.game_started = true
  return require("gui"):set_menu(nil)
end
buttons.options.props.callback = function()
  return require("gui"):set_menu("options")
end
local M = { }
M.update = function(self)
  if not wait_for_input then
    return pointer:setPosition(g.p.x, g.p.y)
  end
end
M.draw = function(self)
  scene:beginFrame()
  love.graphics.push("all")
  love.graphics.setFont(g.use_hires_font and g.font_hires or g.font_no_outline)
  local font_scale = g.use_hires_font and g.hires_scale or 1
  love.graphics.scale(g.scale)
  love.graphics.translate(g.xshift, g.yshift)
  local w1 = love.graphics.getFont():getWidth(buttons.start.props.text()) * font_scale + 10
  local w2 = love.graphics.getFont():getWidth(buttons.options.props.text()) * font_scale + 10
  local w = math.max(w1, w2)
  local y = 88
  buttons.start:render((g.game_width - w) / 2, y, w, Button.height)
  y = y + 12
  buttons.options:render((g.game_width - w) / 2, y, w, Button.height)
  scene:finishFrame()
  return love.graphics.pop()
end
local skip_next_release
M.mousereleased = function(self)
  return pointer:raise("release")
end
M.mousepressed = function(self, button)
  return pointer:raise("press")
end
M.keypressed = function(self, key) end
return M
