local vortex = require("vortex")
local ui = require("ui")
local g = require("global")
local lc = require("engine")
local say = require("say")
local shake = require("shake")
local road = require("road")
local tunnel = require("tunnel")
local audio = require("audio")
local skip = require("skip")
local gui = require("gui")
local lovebird = g.debug and require("3rd.lovebird")
love.update = function(dt)
  if g.paused then
    return 
  end
  dt = math.min(dt, 1 / 30)
  dt = dt * g.time_rate
  if lovebird then
    lovebird.update()
  end
  lc.dialogues:update(dt)
  g.thread_registry:update(dt)
  vortex:update(dt)
  shake:update(dt)
  ui:update(dt)
  lc.game.update(dt)
  road:update(dt)
  tunnel:update(dt)
  say.update(dt)
  g.update_holeegram(dt)
  audio:update(dt)
  skip:update(dt)
  return gui:update()
end
